/*================================================================================
Human Test
================================================================================*/

#include <amxmodx>
#include <fakemeta>
#include <zombieplague>
#include <zombiexp>

// Zombie Attributes
new const hclass_name[] = { "Health" } // name
new const hclass_info[] = { "Colt and extra health" } // description
new const hclass_model[] = { "" } // model
new const hclass_weapons[] = { WEAPON_M4A1, WEAPON_GLOCK18 } // weapons
const hclass_health = 125 // health
const hclass_speed = 240 // speed
const Float:hclass_gravity = 1.0 // gravity
const hclass_level = 1 // level required to use

// Class IDs
new g_hclassid

// Zombie Classes MUST be registered on plugin_precache
public plugin_precache()
{
	new registerText[32]
	formatex( registerText, sizeof registerText - 1, "[ZPXP] %s human", hclass_name)
	
	register_plugin(registerText, "1.0", "Example")
	
	// Register the new class and store ID for reference
	g_hclassid = zpxp_register_human_class(hclass_name, hclass_info, hclass_model, hclass_weapons, hclass_health, hclass_speed, hclass_gravity, hclass_level)
	
	if(g_hclassid == -1)
	{
		server_print("[ZPXP] You have not properly setup your Zombie XP Mod.");
	}
}

// User Infected forward
public zp_user_infected_post(id, infector)
{
	// Check if the infected player is using our custom zombie class
	if (zp_get_user_human_class(id) != g_hclassid) return;
	
	// Undo any settings we have saved here
	
}

public zp_user_humanized_post(id)
{
	// Check if the infected player is using our custom zombie class
	if (zp_get_user_human_class(id) != g_hclassid) return;

	// User turned human
	if (zp_get_user_survivor(id) == 1)
	{
		// He's survivor, remove any changes made in the plugin
		zp_user_infected_post(id, 0)
	} else {
		zp_round_started_human(id)
	}
}

//This is a forward from zpxp, as opposed to ZPs round_start (which is when infection begins) this is the true beginning of the round
public zp_round_started_human(id)
{
	if (zp_get_user_human_class(id) != g_hclassid) return;
	
	// Set our human's powers!
		
}
