/*================================================================================
Human Test
================================================================================*/

#include <amxmodx>
#include <fakemeta>
#include <zombieplague>
#include <zombiexp>

// Zombie Attributes
new const zclass_name[] = { "Health" } // name
new const zclass_info[] = { "Extra health" } // description
new const zclass_model[] = { "zombie_source" } // model
new const zclass_clawmodel[] = { "v_knife_zombie.mdl" } // claw model
const zclass_health = 500 // health
const zclass_speed = 240 // speed
const Float:zclass_gravity = 1.0 // gravity
const Float:zclass_kb = 1.0 // knockback
const zclass_level = 3 // level required to use

// Class IDs
new g_zclassid

public plugin_init()
{
	
}

// Zombie Classes MUST be registered on plugin_precache
public plugin_precache()
{
	new registerText[32]
	formatex( registerText, sizeof registerText - 1, "[ZPXP] %s zombie", zclass_name)
	register_plugin(registerText, "1.0", "Example")

	// Register the new class and store ID for reference
	g_zclassid = zpxp_register_zombie_class(zclass_name, zclass_info, zclass_model, zclass_clawmodel, zclass_health, zclass_speed, zclass_gravity, zclass_kb, zclass_level)
	
	if(g_zclassid == -1)
	{
		server_print("[ZPXP] You have not properly setup your Zombie XP Mod.");
	}
}

// User Infected forward
public zp_user_infected_post(id, infector)
{
	// Check if the infected player is using our custom zombie class
	if (zp_get_user_zombie_class(id) != g_zclassid) return;

	//client_print(id, print_chat, "[ZP] Your %s Zombie", zclass_name)
}

public zp_user_humanized_post(id)
{
	if (zp_get_user_zombie_class(id) != g_zclassid) return;

	//user turned human
	zp_round_started_human(id);
}

public zp_round_started_human(id)
{
	if (zp_get_user_zombie_class(id) != g_zclassid) return;
	
	// User turned human
	// Undo any additional changes we have made here
	
}